Index: /branches/ORCHIDEE_2_2/ORCHIDEE/orchidee.default
===================================================================
--- /branches/ORCHIDEE_2_2/ORCHIDEE/orchidee.default	(revision 7507)
+++ /branches/ORCHIDEE_2_2/ORCHIDEE/orchidee.default	(revision 7508)
@@ -1402,10 +1402,4 @@
 PRINTLEV_modname =  PRINTLEV 
 
-# DRY_SOIL_HEAT_CAPACITY ([J.m^{-3}.K^{-1}] ) :  Dry soil Heat capacity of soils 	{OK_SECHIBA }
-DRY_SOIL_HEAT_CAPACITY =  1.80e+6 
-
-# DRY_SOIL_HEAT_COND ([W.m^{-2}.K^{-1}] ) :  Dry soil Thermal Conductivity of soils 	{OK_SECHIBA}
-DRY_SOIL_HEAT_COND =  0.40  
-
 # SNOW_HEAT_COND ([W.m^{-2}.K^{-1}]) :  Thermal Conductivity of snow 	{OK_SECHIBA  }
 SNOW_HEAT_COND =  0.3 
@@ -1558,4 +1552,7 @@
 BEDROCK_FLAG =  0 
 
+# DRY_SOIL_HEAT_CAPACITY ([J.m^{-3}.K^{-1}] ) :  Dry soil Heat capacity of soils 	{OK_SECHIBA}
+DRY_SOIL_HEAT_CAPACITY =  (1.47, 1.41, 1.34, 1.27, 1.21, 1.21, 1.18, 1.32, 1.23, 1.18, 1.15, 1.09, 1.09)*e+6 
+
 # THERMOSOIL_TPRO (Kelvin [K]) :  Initial soil temperature profile if not found in restart 	{OK_SECHIBA}
 THERMOSOIL_TPRO =  280. 
Index: /branches/ORCHIDEE_2_2/ORCHIDEE/src_parameters/constantes_soil.f90
===================================================================
--- /branches/ORCHIDEE_2_2/ORCHIDEE/src_parameters/constantes_soil.f90	(revision 7507)
+++ /branches/ORCHIDEE_2_2/ORCHIDEE/src_parameters/constantes_soil.f90	(revision 7508)
@@ -70,38 +70,4 @@
     ! Following initializations are only done for option impose_param
     IF ( ok_sechiba .AND. impose_param ) THEN
-
-       !Config Key   = DRY_SOIL_HEAT_CAPACITY
-       !Config Desc  = Dry soil Heat capacity of soils
-       !Config If    = OK_SECHIBA 
-       !Config Def   = 1.80e+6
-       !Config Help  = Values taken from : PIELKE,'MESOSCALE METEOROLOGICAL MODELING',P.384.
-       !Config Units = [J.m^{-3}.K^{-1}] 
-       CALL getin_p("DRY_SOIL_HEAT_CAPACITY",so_capa_dry)
-
-       !! Check parameter value (correct range)
-       IF ( so_capa_dry <= zero ) THEN
-          CALL ipslerr_p(error_level, "config_soil_parameters.", &
-               &     "Wrong parameter value for DRY_SOIL_HEAT_CAPACITY.", &
-               &     "This parameter should be positive. ", &
-               &     "Please, check parameter value in run.def. ")
-       END IF
-
-
-       !Config Key   = DRY_SOIL_HEAT_COND
-       !Config Desc  = Dry soil Thermal Conductivity of soils
-       !Config If    = OK_SECHIBA
-       !Config Def   = 0.40 
-       !Config Help  = Values taken from : PIELKE,'MESOSCALE METEOROLOGICAL MODELING',P.384.
-       !Config Units = [W.m^{-2}.K^{-1}] 
-       CALL getin_p("DRY_SOIL_HEAT_COND",so_cond_dry)
-
-       !! Check parameter value (correct range)
-       IF ( so_cond_dry <= zero ) THEN
-          CALL ipslerr_p(error_level, "config_soil_parameters.", &
-               &     "Wrong parameter value for DRY_SOIL_HEAT_COND.", &
-               &     "This parameter should be positive. ", &
-               &     "Please, check parameter value in run.def. ")
-       END IF
-
 
        !Config Key   = SNOW_HEAT_COND
Index: /branches/ORCHIDEE_2_2/ORCHIDEE/src_parameters/constantes_soil_var.f90
===================================================================
--- /branches/ORCHIDEE_2_2/ORCHIDEE/src_parameters/constantes_soil_var.f90	(revision 7507)
+++ /branches/ORCHIDEE_2_2/ORCHIDEE/src_parameters/constantes_soil_var.f90	(revision 7508)
@@ -75,11 +75,4 @@
 
   !! Parameters for soil thermodynamics
-
-  REAL(r_std), SAVE :: so_capa_dry = 1.80e+6            !! Dry soil Heat capacity of soils 
-                                                        !! @tex $(J.m^{-3}.K^{-1})$ @endtex 
-!$OMP THREADPRIVATE(so_capa_dry)
-  REAL(r_std), SAVE :: so_cond_dry = 0.40               !! Dry soil Thermal Conductivity of soils
-                                                        !! @tex $(W.m^{-2}.K^{-1})$ @endtex
-!$OMP THREADPRIVATE(so_cond_dry)
   REAL(r_std), SAVE :: sn_cond = 0.3                    !! Thermal Conductivity of snow 
                                                         !! @tex $(W.m^{-2}.K^{-1})$ @endtex  
@@ -206,5 +199,5 @@
 &     0.25_r_std /)  ! oxisols                 
 
-  REAL(r_std),PARAMETER,DIMENSION(nscm_usda) :: so_capa_dry_ns_usda = &  !! Dry soil Heat capacity of soils,J.m^{-3}.K^{-1}
+  REAL(r_std),PARAMETER,DIMENSION(nscm_usda) :: so_capa_dry_usda = &     !! Dry soil Heat capacity of soils,J.m^{-3}.K^{-1}
  & (/ 1.47e+6_r_std, 1.41e+6_r_std, 1.34e+6_r_std, 1.27e+6_r_std, &      !! Pielke [2002, 2013]
  &    1.21e+6_r_std, 1.21e+6_r_std, 1.18e+6_r_std, 1.32e+6_r_std, &
Index: /branches/ORCHIDEE_2_2/ORCHIDEE/src_sechiba/thermosoil.f90
===================================================================
--- /branches/ORCHIDEE_2_2/ORCHIDEE/src_sechiba/thermosoil.f90	(revision 7507)
+++ /branches/ORCHIDEE_2_2/ORCHIDEE/src_sechiba/thermosoil.f90	(revision 7508)
@@ -154,6 +154,6 @@
   REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:)   :: QZ                       !! quartz content [-]
 !$OMP THREADPRIVATE(QZ)
-  REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:)   :: so_capa_dry_ns           !! Dry soil Heat capacity of soils,J.m^{-3}.K^{-1} 
-!$OMP THREADPRIVATE(so_capa_dry_ns)
+  REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:)   :: so_capa_dry              !! Dry soil Heat capacity of soils,J.m^{-3}.K^{-1} 
+!$OMP THREADPRIVATE(so_capa_dry)
   REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:)   :: so_capa_ice              !! Heat capacity of saturated frozen soil (J/K/m3)
 !$OMP THREADPRIVATE(so_capa_ice)   
@@ -372,6 +372,6 @@
     IF (ier /= 0) CALL ipslerr_p(3,'thermosoil_initialize', 'Error in allocation of QZ','','')
 
-    ALLOCATE (so_capa_dry_ns(nscm),stat=ier)
-    IF (ier /= 0) CALL ipslerr_p(3,'thermosoil_initialize', 'Error in allocation of so_capa_dry_ns','','')
+    ALLOCATE (so_capa_dry(nscm),stat=ier)
+    IF (ier /= 0) CALL ipslerr_p(3,'thermosoil_initialize', 'Error in allocation of so_capa_dry','','')
     
     ALLOCATE (so_capa_ice(kjpindex),stat=ier)
@@ -381,6 +381,23 @@
     !! Soil texture choose : Now useless since njsc defines the dominant texture within 13 classes whichever the soil map
     QZ(:) = QZ_usda(:)
-    so_capa_dry_ns(:) = so_capa_dry_ns_usda(:)
-    
+    so_capa_dry(:) = so_capa_dry_usda(:)
+    
+    !Config Key   = DRY_SOIL_HEAT_CAPACITY
+    !Config Desc  = Dry soil Heat capacity of soils
+    !Config If    = OK_SECHIBA
+    !Config Def   = (1.47, 1.41, 1.34, 1.27, 1.21, 1.21, 1.18, 1.32, 1.23, 1.18, 1.15, 1.09, 1.09)*e+6
+    !Config Help  = Values taken from : Pielke [2002, 2013]
+    !Config Units = [J.m^{-3}.K^{-1}] 
+    CALL getin_p("DRY_SOIL_HEAT_CAPACITY",so_capa_dry)
+    
+    !! Check parameter value (correct range)
+    IF ( MINVAL(so_capa_dry(:)) <= zero ) THEN
+       CALL ipslerr_p(3, "thermosoil_initialize", &
+            "Wrong parameter value for DRY_SOIL_HEAT_CAPACITY.", &
+            "This parameter should be positive. ", &
+            "Please, check parameter value in run.def or orchidee.def. ")
+    END IF
+
+
     !! 2. Initialize variable from restart file or with default values 
     
@@ -1627,5 +1644,5 @@
       DO jg = 1, ngrnd
          jst = njsc(ji)
-         pcapa_tmp(ji, jg) = so_capa_dry_ns(jst) * (1-mcs(ji)) + water_capa * tmc_layt(ji,jg)/mille/dlt(jg)
+         pcapa_tmp(ji, jg) = so_capa_dry(jst) * (1-mcs(ji)) + water_capa * tmc_layt(ji,jg)/mille/dlt(jg)
          !
          ! 2. Calculate volumetric heat capacity with allowance for permafrost
@@ -1638,5 +1655,5 @@
 	    profil_froz(ji,jg) = 1.
  	    pcappa_supp(ji,jg)= 0.
-            pcapa(ji, jg) = so_capa_dry_ns(jst) * (1-mcs(ji)) + so_capa_ice(ji) * tmc_layt(ji,jg) / mille / dlt(jg)
+            pcapa(ji, jg) = so_capa_dry(jst) * (1-mcs(ji)) + so_capa_ice(ji) * tmc_layt(ji,jg) / mille / dlt(jg)
             rho_tot = rho_soil * (1-mcs(ji)) + rho_ice * tmc_layt(ji,jg) / mille / dlt(jg) 
             pcapa_spec(ji, jg) = pcapa(ji, jg) / rho_tot
@@ -1655,10 +1672,10 @@
 
     	   IF (ok_freeze_thaw_latent_heat) THEN
-              pcapa(ji, jg) = so_capa_dry_ns(jst) * (1-mcs(ji)) + &
+              pcapa(ji, jg) = so_capa_dry(jst) * (1-mcs(ji)) + &
                 water_capa * tmc_layt(ji,jg)/mille / dlt(jg) * xx + &
                 so_capa_ice(ji) * tmc_layt(ji,jg) / mille/dlt(jg) * (1.-xx) + &
                 shum_ngrnd_perma(ji,jg)*mcs(ji)*lhf*rho_water/fr_dT
 	   ELSE
-              pcapa(ji, jg) = so_capa_dry_ns(jst) * (1-mcs(ji)) + &
+              pcapa(ji, jg) = so_capa_dry(jst) * (1-mcs(ji)) + &
                 water_capa * tmc_layt(ji,jg)/mille / dlt(jg) * xx + &
                 so_capa_ice(ji) * tmc_layt(ji,jg) / mille/dlt(jg) * (1.-xx)
@@ -1752,5 +1769,5 @@
          DO ji = 1,kjpindex
             jst = njsc(ji)
-            pcapa_tmp(ji, jg) = so_capa_dry_ns(jst) * (1-mcs(ji)) + water_capa * tmc_layt(ji,jg)/mille/dlt(jg)
+            pcapa_tmp(ji, jg) = so_capa_dry(jst) * (1-mcs(ji)) + water_capa * tmc_layt(ji,jg)/mille/dlt(jg)
             pcapa(ji,jg) = pcapa_tmp(ji, jg)
             pcapa_en(ji,jg) = pcapa_tmp(ji, jg)