Index: branches/ORCHIDEE_2_2/ORCHIDEE/src_xml/field_def_orchidee.xml
===================================================================
--- branches/ORCHIDEE_2_2/ORCHIDEE/src_xml/field_def_orchidee.xml	(revision 7511)
+++ branches/ORCHIDEE_2_2/ORCHIDEE/src_xml/field_def_orchidee.xml	(revision 7515)
@@ -51,8 +51,4 @@
     <field id="albedo_nir" name="alb_nir" long_name="Albedo near infrared" unit="1"/>
     <field id="albedo_glob" name="albedo_glob" long_name="Mean albedo" unit="1"> (albedo_vis + albedo_nir)*0.5 </field>
-    <field id="asoilcol" name="asoilcol" long_name="Availability of data for the soil color interpolation (negative values if no data found)" unit="1"  operation="once" freq_offset="0ts"/>
-    <field id="aalb_bg" name="aalb_bg" long_name="Availability of data for the albedo interpolation from MODIS related data-set (negative values if no data found)" unit="1"  operation="once" freq_offset="0ts"/>
-    <field id="atext" name="atext" long_name="Availability of data for the soil texture interpolation (negative values if no data found)" unit="1"  operation="once" freq_offset="0ts"/>
-    <field id="areftemp" name="areftemp" long_name="Availability of data for the reftemp interpolation (negative values if no data found)" unit="1"  operation="once" freq_offset="0ts"/>
     <field id="vevapp" name="evap_sec" long_name="Total Evaporation" unit="kg/m^2/s"/>
     <field id="vevapp_day" name="evap" field_ref="vevapp" long_name="Evaporation per day" unit="mm/d" > vevapp*86400  </field>
@@ -71,7 +67,5 @@
     <field id="netrad" name="netrad" long_name="Net radiation" unit="W/m^2"/>
     <field id="lai" name="lai" long_name="Leaf Area Index per PFT" unit="1" grid_ref="grid_nvm"/>
-    <field id="alaimap" name="alaimap" long_name="Availability of data for the lai interpolation (negative values if no data found)" unit="1"  operation="once" freq_offset="0ts"/>
     <field id="reinf_slope" name="reinf_slope" long_name="Slope index for each grid box" unit="1" operation="once" freq_offset="0ts"/>
-    <field id="aslope" name="aslope" long_name="Availability of data for the slope interpolation (negative values if no data found)" unit="1"  operation="once" freq_offset="0ts"/>
     <field id="njsc" name="soilindex" long_name="Index of soil texture" unit="1" operation="once" freq_offset="0ts"/>
     <field id="clayfraction" name="clayfraction" long_name="Fraction of clay particles in soil (grid-cell mean)" unit="1" grid_ref="grid_nslm" operation="once" freq_offset="0ts"/>
@@ -110,6 +104,4 @@
     <field id="vegetfrac" name="vegetfrac" long_name="Fraction of vegetation" unit="1" grid_ref="grid_nvm"/>
     <field id="maxvegetfrac" name="maxvegetfrac" long_name="Maximum fraction of vegetation" unit="1" grid_ref="grid_nvm"/>
-    <field id="aveget" name="aveget" long_name="Availability of data for the vegetation fraction interpolation (negative values if no data found)" unit="1"  operation="once"  freq_offset="0ts"/>
-    <field id="aveget5k" name="aveget5k" long_name="Availability of data for the Olson vegetation fraction interpolation (negative values if no data found)" unit="1"  operation="once" freq_offset="0ts"/>
     <field id="tot_bare_soil" name="tot_bare_soil" long_name="Total Bare Soil Fraction" unit="%"/>
     <field id="nobiofrac" name="nobiofrac" long_name="Fraction of other surface types" unit="1" grid_ref="grid_nnobio"/>
@@ -198,7 +190,4 @@
     <field id="N_qt_WRICE_year" name="N_qt_WRICE_year" long_name="N fertilizers applied on wetland rice - Read in an input file" unit="kgN/yr" operation="once" freq_offset="0ts"/>
     <field id="N_qt_OTHER_year" name="N_qt_OTHER_year" long_name="N fertilizers applied on other crops and grasses - Read in an input file" unit="kgN/yr" operation="once" freq_offset="0ts"/>
-    <field id="achem_wrice" name="achem_wrice" long_name="Availability of data for the rice fertilizers interpolation (negative values if no data found)" unit="1"  operation="once" freq_offset="0ts"/>
-    <field id="achem_other" name="achem_other" long_name="Availability of data for the other crops fertilizers interpolation (negative values if no data found)" unit="1"  operation="once" freq_offset="0ts"/>
-    <field id="achem_co2" name="achem_co2" long_name="Availability of data for the co2 bbg interpolation (negative values if no data found)" unit="1"  operation="once" freq_offset="0ts"/>
     <field id="flx_iso" name="flx_iso" long_name="Isoprene emissions from vegetation" unit="kgC/m^2/s" grid_ref="grid_nvm"/>
     <field id="flx_mono" name="flx_mono" long_name="Monoterpene emissions from vegetation" unit="kgC/m^2/s" grid_ref="grid_nvm"/>
@@ -359,19 +348,33 @@
     <field id="mrro_lut" name="mrroLut" long_name="Total runoff from land use tile" unit="kg m-2 s-1" grid_ref="grid_nlut"/>
     <field id="gpplut" name="gppLut" long_name="Gross primary productivity on Landuse tiles" unit="kgC m-2 s-1" grid_ref="grid_nlut" />
-    <field id="interp_diag_aveget" name="interp_diag_aveget" long_name="aveget read from file" operation="once" freq_offset="0ts"/>
-    <field id="interp_diag_vegetrefrac" name="interp_diag_vegetrefrac" grid_ref="grid_nvm" long_name="vegetfrac read from file" operation="once" freq_offset="0ts"/>
-    <field id="interp_diag_atext" name="interp_diag_atext" long_name="axtext read from file" operation="once" freq_offset="0ts"/>
-    <field id="interp_diag_soilclass" name="interp_diag_soilclass"     grid_ref="grid_nscm" long_name="soilclass read from file" operation="once" freq_offset="0ts"/>
-    <field id="interp_diag_clayfraction" name="interp_diag_clayfraction" long_name="clayfraction read from file" operation="once" freq_offset="0ts" />
-    <field id="interp_diag_aslope" name="interp_diag_aslope" long_name="aslope read from file" operation="once" freq_offset="0ts"   />
-    <field id="interp_diag_reinf_slope" name="interp_diag_reinf_slope" long_name="reinf_slope read from file" operation="once" freq_offset="0ts" />
+
+    <!-- Varaibles interp_diag_xxx and interp_avail_xxx are written just after reading and interpolating from file and are used for validation -->
+    <field id="interp_avail_aveget" name="interp_avail_aveget" long_name="Availability of data for the vegetation fraction interpolation (negative values if no data found)" unit="1" operation="once" freq_offset="0ts"/>
+    <field id="interp_diag_vegetrefrac" name="interp_diag_vegetrefrac" grid_ref="grid_nvm" long_name="vegetfrac read from PFTmap file" operation="once" freq_offset="0ts"/>
+    <field id="interp_diag_veget_next" name="interp_diag_veget_next" grid_ref="grid_nvm" long_name="Final vegetfrac read from PFTmap file" operation="once" freq_offset="0ts"/>
+    <field id="interp_avail_atext" name="interp_avail_atext" long_name="Availability of data for the soil texture interpolation (negative values if no data found)" unit="1" operation="once" freq_offset="0ts"/>
+    <field id="interp_diag_soilclass" name="interp_diag_soilclass"     grid_ref="grid_nscm" long_name="soilclass read from soils_param file" operation="once" freq_offset="0ts"/>
+    <field id="interp_diag_njsc" name="interp_diag_njsc" long_name="njsc after reading of soilclass from soils_param file" operation="once" freq_offset="0ts"/>
+    <field id="interp_diag_clayfraction" name="interp_diag_clayfraction" long_name="clayfraction read from soils_param file" operation="once" freq_offset="0ts" />
+    <field id="interp_diag_sandfraction" name="interp_diag_sandfraction" long_name="sandfraction read from soils_param file" operation="once" freq_offset="0ts" />
+    <field id="interp_diag_siltfraction" name="interp_diag_siltfraction" long_name="siltfraction read from soils_param file" operation="once" freq_offset="0ts" />
+    <field id="interp_avail_aslope" name="interp_avail_aslope" long_name="Availability of data for the slope interpolation (negative values if no data found)" unit="1" operation="once" freq_offset="0ts"   />
+    <field id="interp_diag_reinf_slope" name="interp_diag_reinf_slope" long_name="reinf_slope read from topography file" operation="once" freq_offset="0ts" />
     <field id="interp_diag_alb_vis" name="interp_diag_alb_vis" long_name="alb_vis read from file" operation="once" freq_offset="0ts" />
     <field id="interp_diag_alb_nir" name="interp_diag_alb_nir" long_name="alb_nir read from file" operation="once" freq_offset="0ts" />
+    <field id="interp_avail_aalb_bg" name="interp_avail_aalb_bg" long_name="Availability of data for the albedo interpolation from MODIS related data-set (negative values if no data found)" unit="1" operation="once" freq_offset="0ts"/>
+    <field id="interp_avail_asoilcol" name="interp_avail_asoilcol" long_name="Availability of data for the soil color interpolation (negative values if no data found)" unit="1"  operation="once" freq_offset="0ts"/>
     <field id="interp_diag_N_qt_WRICE_year" name="interp_diag_N_qt_WRICE_year" long_name="N_qt_WRICE_year read from file" operation="once" freq_offset="0ts" />
     <field id="interp_diag_N_qt_OTHER_year" name="interp_diag_N_qt_OTHER_year" long_name="N_qt_OTHER_year read from file" operation="once" freq_offset="0ts" />
+    <field id="interp_avail_achem_wrice" name="interp_avail_achem_wrice" long_name="Availability of data for the rice fertilizers interpolation (negative values if no data found)" unit="1"  operation="once" freq_offset="0ts"/>
+    <field id="interp_avail_achem_other" name="interp_avail_achem_other" long_name="Availability of data for the other crops fertilizers interpolation (negative values if no data found)" unit="1"  operation="once" freq_offset="0ts"/>
+    <field id="interp_avail_achem_co2" name="interp_avail_achem_co2" long_name="Availability of data for the co2 bbg interpolation (negative values if no data found)" unit="1"  operation="once" freq_offset="0ts"/>
     <field id="interp_diag_flx_co2_bbg_year" name="interp_diag_flx_co2_bbg_year" long_name="flx_co2_bbg_year read from file" operation="once" freq_offset="0ts" />
-    <field id="interp_diag_lai" grid_ref="grid_from_lai" name="interp_diag_lai" long_name="lai read from file" operation="once" freq_offset="0ts"/>
+    <field id="interp_avail_alaimap" name="interp_avail_alaimap" long_name="Availability of data for the lai interpolation (negative values if no data found)" operation="once" freq_offset="0ts"/>
+    <field id="interp_diag_lai" grid_ref="grid_from_lai" name="interp_diag_lai" long_name="lai read from file" operation="once" freq_offset="0ts" enabled=".FALSE."/>
     <field id="interp_diag_reftemp" name="interp_diag_reftemp" long_name="reftemp read from file" operation="once" freq_offset="0ts"/>
+    <field id="interp_avail_areftemp" name="interp_avail_areftemp" long_name="Availability of data for the reftemp interpolation (negative values if no data found)" unit="1" operation="once" freq_offset="0ts"/>
     <field id="interp_diag_woodharvest" name="interp_diag_woodharvest" long_name="woodharvest read from file" operation="once" freq_offset="0ts"/>
+
 
     <field id="znetco2" name="znetco2" long_name="Sum CO2 flux over PFTs (variable in interface to LMDZ)" unit="kgC m-2 s-1" />