Index: branches/ORCHIDEE_2_2/ORCHIDEE/orchidee.default
===================================================================
--- branches/ORCHIDEE_2_2/ORCHIDEE/orchidee.default	(revision 7546)
+++ branches/ORCHIDEE_2_2/ORCHIDEE/orchidee.default	(revision 7547)
@@ -770,5 +770,8 @@
 
 # IMPOSE_SOILT ([FLAG]) :  Should the soil type be prescribed ? 	{}
-IMPOSE_SOILT =  n 
+IMPOSE_SOILT =  n
+
+# IMPOSE_SLOPE ([FLAG]) :  Should reinf_slope be prescribed ? 	{}
+IMPOSE_SLOPE =  n
 
 # LAI_MAP ([FLAG]) :  Read the LAI map 	{OK_SECHIBA or OK_STOMATE}
@@ -1474,5 +1477,5 @@
 GET_SLOPE =  n 
 
-# REINF_SLOPE ([-]) :  Fraction of reinfiltrated surface runoff  	{}
+# REINF_SLOPE ([-]) :  Fraction of reinfiltrated surface runoff  	{IMPOSE_SLOPE}
 REINF_SLOPE =  0.1 
 
Index: branches/ORCHIDEE_2_2/ORCHIDEE/src_parameters/constantes.f90
===================================================================
--- branches/ORCHIDEE_2_2/ORCHIDEE/src_parameters/constantes.f90	(revision 7546)
+++ branches/ORCHIDEE_2_2/ORCHIDEE/src_parameters/constantes.f90	(revision 7547)
@@ -227,4 +227,13 @@
     !ENDIF
 
+    !Config Key   = IMPOSE_SLOPE
+    !Config Desc  = Should reinf_slope be prescribed ?
+    !Config Def   = n
+    !Config If    = 
+    !Config Help  = This flag allows the user to impose a uniform fraction of  
+    !Config         reinfiltrated surface runoff, with value REINF_SLOPE 
+    !Config Units = [FLAG]
+    CALL getin_p('IMPOSE_SLOPE', impslope)
+       
     !Config Key   = LAI_MAP
     !Config Desc  = Read the LAI map
Index: branches/ORCHIDEE_2_2/ORCHIDEE/src_parameters/constantes_var.f90
===================================================================
--- branches/ORCHIDEE_2_2/ORCHIDEE/src_parameters/constantes_var.f90	(revision 7546)
+++ branches/ORCHIDEE_2_2/ORCHIDEE/src_parameters/constantes_var.f90	(revision 7547)
@@ -352,4 +352,6 @@
   LOGICAL, SAVE :: impsoilt = .FALSE.      !! Impose soil ? (true/false)
 !$OMP THREADPRIVATE(impsoilt)
+  LOGICAL, SAVE :: impslope = .FALSE.      !! Impose reinf_slope ? (true/false)
+!$OMP THREADPRIVATE(impslope)
   LOGICAL, SAVE :: do_now_stomate_lcchange = .FALSE.  !! Time to call lcchange in stomate_lpj
 !$OMP THREADPRIVATE(do_now_stomate_lcchange)
Index: branches/ORCHIDEE_2_2/ORCHIDEE/src_sechiba/slowproc.f90
===================================================================
--- branches/ORCHIDEE_2_2/ORCHIDEE/src_sechiba/slowproc.f90	(revision 7546)
+++ branches/ORCHIDEE_2_2/ORCHIDEE/src_sechiba/slowproc.f90	(revision 7547)
@@ -1281,17 +1281,7 @@
     CALL restget_p (rest_id, var_name, nbp_glo, 1, 1, kjit, .TRUE., reinf_slope, "gather", nbp_glo, index_g)
 
-    !! 3.b We can also read from a map or prescribe, depending on GET_SLOPE
-
-    !Config Key   = GET_SLOPE
-    !Config Desc  = Read slopes from file and do the interpolation
-    !Config Def   = n
-    !Config If    =
-    !Config Help  = Needed for reading the slopesfile and doing the interpolation. This will be
-    !               used by the re-infiltration parametrization
-    !Config Units = [FLAG]
-    get_slope = .FALSE.
-    CALL getin_p('GET_SLOPE',get_slope)
-
-    IF (get_slope) THEN
+    !! 3.b We can also read from a map or prescribe, depending on IMPOSE_SLOPE
+
+    IF (impslope) THEN
 
        !! Impose a constant value from the run.def (not anymore controlled by impveg)
@@ -1300,5 +1290,5 @@
        !Config Desc  = Fraction of reinfiltrated surface runoff 
        !Config Def   = 0.1
-       !Config If    = 
+       !Config If    = IMPOSE_SLOPE
        !Config Help  = Determines the reinfiltration ratio in the grid box due to flat areas
        !Config Units = [-]
@@ -1308,5 +1298,15 @@
     ELSE
 
-       !! Else, if nof found from restart, we read from a map 
+       !Config Key   = GET_SLOPE
+       !Config Desc  = Read slopes from file and do the interpolation
+       !Config Def   = n
+       !Config If    =
+       !Config Help  = Needed for reading the slope file and doing the interpolation. This will be
+       !               used by the re-infiltration parametrization
+       !Config Units = [FLAG]
+       get_slope = .FALSE.
+       CALL getin_p('GET_SLOPE',get_slope)
+
+       !! Else, if not found from restart or GET_SLOPE = T, we read from a map 
        IF ( MINVAL(reinf_slope) .EQ. MAXVAL(reinf_slope) .AND. MAXVAL(reinf_slope) .EQ. val_exp .OR. get_slope) THEN
           IF (printlev_loc>=4) WRITE (numout,*) 'reinf_slope was not in restart file. Now call slowproc_slope'