Index: /branches/ORCHIDEE_2_2/ORCHIDEE/orchidee.default
===================================================================
--- /branches/ORCHIDEE_2_2/ORCHIDEE/orchidee.default	(revision 7819)
+++ /branches/ORCHIDEE_2_2/ORCHIDEE/orchidee.default	(revision 7820)
@@ -169,4 +169,7 @@
 IMPOSE_PARAM =  y 
 
+# PRINTLEV ([0, 1, 2, 3, 4]) :  Print level for text output 	{}
+PRINTLEV =  2 
+
 # DEPTH_MAX_T (m) :  Maximum depth of the soil thermodynamics 	{}
 DEPTH_MAX_T =  90.0 
@@ -770,8 +773,8 @@
 
 # IMPOSE_SOILT ([FLAG]) :  Should the soil type be prescribed ? 	{}
-IMPOSE_SOILT =  n
+IMPOSE_SOILT =  n 
 
 # IMPOSE_SLOPE ([FLAG]) :  Should reinf_slope be prescribed ? 	{}
-IMPOSE_SLOPE =  n
+IMPOSE_SLOPE =  n 
 
 # LAI_MAP ([FLAG]) :  Read the LAI map 	{OK_SECHIBA or OK_STOMATE}
@@ -964,4 +967,43 @@
 ZSNOWCMPCT_VR =  0.018 
 
+# IRRIG_DOSMAX ([kg.m^{-2}/hour]) :  The maximum irrigation water injected per hour (kg.m^{-2}/hour) 	{DO_IRRIGATION AND old_irrig_scheme }
+IRRIG_DOSMAX =  1. 
+
+# CUM_NROOT_THR ([]) :  Cumulated nroot threshoold to define root zone, and calculate water deficit for irrigation 	{DO_IRRIGATION AND old_irrig_scheme }
+CUM_NROOT_THR =  0.90 
+
+# IRRIGATED_SOILTILE ([FLAG]) :  Do we introduce a new soil tile for irrigated croplands? 	{DO_IRRIGATION AND old_irrig_scheme }
+IRRIGATED_SOILTILE =  n 
+
+# OLD_IRRIG_SCHEME ([FLAG]) :  Do we run with the old irrigation scheme? 	{DO_IRRIGATION}
+OLD_IRRIG_SCHEME =  n 
+
+# IRRIG_ST ([]) :  Which is the soil tile with irrigation flux 	{DO_IRRIGATION and old_irrig_scheme }
+IRRIG_ST =  3 
+
+# AVAIL_RESERVE ([]) :  Max. fraction of routing reservoir volume that can be used for irrigation 	{DO_IRRIGATION and old_irrig_scheme }
+AVAIL_RESERVE =  0.9,0.0,0.9 
+
+# BETA_IRRIG ([]) :  Threshold multiplier of Target SM to calculate root deficit 	{DO_IRRIGATION and old_irrig_scheme }
+BETA_IRRIG =  1. 
+
+# LAI_IRRIG_MIN ([m2/m2]) :  Min. LAI (Leaf Area Index) to trigger irrigation 	{DO_IRRIGATION and old_irrig_scheme }
+LAI_IRRIG_MIN =  0.1 
+
+# IRRIG_MAP_DYNAMIC_FLAG ([FLAG]) :  Do we use a dynamic irrig map? 	{DO_IRRIGATION }
+IRRIG_MAP_DYNAMIC_FLAG =  n 
+
+# SELECT_SOURCE_IRRIG ([FLAG]) :  Do we use the new priorization scheme, based on maps of equipped area with surface water? 	{DO_IRRIGATION }
+SELECT_SOURCE_IRRIG =  n 
+
+# REINFILTR_IRRIGFIELD ([FLAG]) :  DO_IRRIGATION 	{DO_IRRIGATION }
+REINFILTR_IRRIGFIELD =  n 
+
+# REINF_SLOPE_CROPPARAM ([FRACTION 0-1]) :  DO_IRRIGATION 	{DO_IRRIGATION }
+REINF_SLOPE_CROPPARAM =  0.8 
+
+# A_STREAM_ADDUCTION   ([FRACTION 0-1]) :  DO_IRRIGATION 	{DO_IRRIGATION }
+A_STREAM_ADDUCTION   =  zero 
+
 # CB ([-] ) :  Constant of the Louis scheme  	{OK_SECHIBA}
 CB =  5.0 
@@ -1399,7 +1441,4 @@
 EVERYWHERE_INIT =  0.05  
 
-# PRINTLEV ([0, 1, 2, 3, 4]) :  Print level for text output 	{}
-PRINTLEV =  2 
-
 # PRINTLEV_modname ([0, 1, 2, 3, 4]) :  Specific print level of text output for the module "modname". Default as PRINTLEV. 	{}
 PRINTLEV_modname =  PRINTLEV 
@@ -1474,10 +1513,10 @@
 mcw =  0.0884 if caclulated from default 5 parameters above 
 
+# REINF_SLOPE ([-]) :  Fraction of reinfiltrated surface runoff  	{IMPOSE_SLOPE}
+REINF_SLOPE =  0.1 
+
 # GET_SLOPE ([FLAG]) :  Read slopes from file and do the interpolation 	{}
 GET_SLOPE =  n 
 
-# REINF_SLOPE ([-]) :  Fraction of reinfiltrated surface runoff  	{IMPOSE_SLOPE}
-REINF_SLOPE =  0.1 
-
 # SECHIBA_QSINT  ([m]) :  Interception reservoir coefficient 	{OK_SECHIBA }
 SECHIBA_QSINT  =  0.02 
@@ -1531,4 +1570,10 @@
 WOODHARVEST_FILE =  woodharvest.nc 
 
+# IRRIGATION_DYN_FILE ([FILE]) :  Name of file from which the DYNAMIC irrigation fraction map is to be read 	{IRRIG_DYN}
+IRRIGATION_DYN_FILE =  IRRIGmap.nc 
+
+# FRACTION_AEI_SW_FILE ([FILE]) :  Name of file with AEI with SW 	{SELECT_SOURCE_IRRIG}
+FRACTION_AEI_SW_FILE =  AEI_SW_pct.nc 
+
 # SOILALB_FILE ([FILE]) :  Name of file from which the bare soil albedo 	{NOT(IMPOSE_AZE)}
 SOILALB_FILE =  soils_param.nc 
@@ -1654,5 +1699,5 @@
 ROUTING_RIVERS =  50 
 
-# DO_FLOODINFILT ([FLAG]) :  Should floodplains reinfiltrate into the soil  	{RIVER_ROUTING}
+# DO_FLOODINFILT ([FLAG]) :  Should floodplains reinfiltrate into the soil 	{RIVER_ROUTING}
 DO_FLOODINFILT =  n 
 
@@ -1660,35 +1705,35 @@
 DO_SWAMPS =  n 
 
-# DO_PONDS ([FLAG]) :  Should we include ponds  	{RIVER_ROUTING}
+# DO_PONDS ([FLAG]) :  Should we include ponds 	{RIVER_ROUTING}
 DO_PONDS =  n 
 
-# SLOW_TCST ([days]) :  Time constant for the slow reservoir  	{RIVER_ROUTING }
-SLOW_TCST =  25.0  
-
-# FAST_TCST ([days]) :  Time constant for the fast reservoir  	{RIVER_ROUTING }
-FAST_TCST =  3.0  
-
-# STREAM_TCST ([days]) :  Time constant for the stream reservoir  	{RIVER_ROUTING}
+# SLOW_TCST ([days]) :  Time constant for the slow reservoir 	{RIVER_ROUTING}
+SLOW_TCST =  25.0 
+
+# FAST_TCST ([days]) :  Time constant for the fast reservoir 	{RIVER_ROUTING}
+FAST_TCST =  3.0 
+
+# STREAM_TCST ([days]) :  Time constant for the stream reservoir 	{RIVER_ROUTING}
 STREAM_TCST =  0.24 
 
-# FLOOD_TCST ([days]) :  Time constant for the flood reservoir  	{RIVER_ROUTING}
+# FLOOD_TCST ([days]) :  Time constant for the flood reservoir 	{RIVER_ROUTING}
 FLOOD_TCST =  4.0 
 
-# SWAMP_CST ([-]) :  Fraction of the river that flows back to swamps  	{RIVER_ROUTING}
+# SWAMP_CST ([-]) :  Fraction of the river that flows back to swamps 	{RIVER_ROUTING}
 SWAMP_CST =  0.2 
 
-# FLOOD_BETA ([-] ) :  Parameter to fix the shape of the floodplain   	{RIVER_ROUTING}
+# FLOOD_BETA ([-]) :  Parameter to fix the shape of the floodplain 	{RIVER_ROUTING}
 FLOOD_BETA =  2.0 
 
-# POND_BETAP ([-] ) :  Ratio of the basin surface intercepted by ponds and the maximum surface of ponds 	{RIVER_ROUTING}
+# POND_BETAP ([-]) :  Ratio of the basin surface intercepted by ponds and the maximum surface of ponds 	{RIVER_ROUTING}
 POND_BETAP =  0.5 
 
-# FLOOD_CRI ([mm] ) :  Potential height for which all the basin is flooded 	{DO_FLOODPLAINS or DO_PONDS}
+# FLOOD_CRI ([mm]) :  Potential height for which all the basin is flooded 	{DO_FLOODPLAINS or DO_PONDS}
 FLOOD_CRI =  2000. 
 
-# POND_CRI ([mm] ) :  Potential height for which all the basin is a pond 	{DO_FLOODPLAINS or DO_PONDS}
+# POND_CRI ([mm]) :  Potential height for which all the basin is a pond 	{DO_FLOODPLAINS or DO_PONDS}
 POND_CRI =  2000. 
 
-# MAX_LAKE_RESERVOIR ([kg/m2(routing area)] ) :  Maximum limit of water in lake_reservoir 	{RIVER_ROUTING}
+# MAX_LAKE_RESERVOIR ([kg/m2(routing area)]) :  Maximum limit of water in lake_reservoir 	{RIVER_ROUTING}
 MAX_LAKE_RESERVOIR =  7000 
 
Index: /branches/ORCHIDEE_2_2/ORCHIDEE/src_parameters/constantes.f90
===================================================================
--- /branches/ORCHIDEE_2_2/ORCHIDEE/src_parameters/constantes.f90	(revision 7819)
+++ /branches/ORCHIDEE_2_2/ORCHIDEE/src_parameters/constantes.f90	(revision 7820)
@@ -953,5 +953,5 @@
 
     !   To run with new irrigation scheme
-    !Config Key   = irrig_map_dynamic
+    !Config Key   = IRRIG_MAP_DYNAMIC_FLAG
     !Config Desc  = Do we use a dynamic irrig map?
     !Config If    = DO_IRRIGATION = T
@@ -962,5 +962,5 @@
 
     !   To run with new irrigation scheme
-    !Config Key   = select_source_irrig
+    !Config Key   = SELECT_SOURCE_IRRIG
     !Config Desc  = Do we use the new priorization scheme, based on maps of equipped area with surface water?
     !Config If    = DO_IRRIGATION = T
@@ -971,5 +971,5 @@
 
     !   Do we reinfiltrate all/part of runoff in crop soil tile?
-    !Config Key   = Reinfiltr_IrrigField
+    !Config Key   = REINFILTR_IRRIGFIELD
     !Config Desc  = DO_IRRIGATION
     !Config If    = DO_IRRIGATION = T
@@ -980,5 +980,5 @@
 
     !   Externalized reinf_slope for reinfiltration in irrigated cropland
-    !Config Key   = reinf_slope_cropParam
+    !Config Key   = REINF_SLOPE_CROPPARAM
     !Config Desc  = DO_IRRIGATION
     !Config If    = DO_IRRIGATION = T, REINFILTR_IRRIGFIELD = T
@@ -989,5 +989,5 @@
 
     !   Externalized for available volume to adduction
-    !Config Key   = a_stream_adduction  
+    !Config Key   = A_STREAM_ADDUCTION  
     !Config Desc  = DO_IRRIGATION
     !Config If    = DO_IRRIGATION = T