Index: /tags/ORCHIDEE_4_1/ORCHIDEE_OL/OOL_SEC/PARAM/orchidee.def
===================================================================
--- /tags/ORCHIDEE_4_1/ORCHIDEE_OL/OOL_SEC/PARAM/orchidee.def	(revision 7876)
+++ /tags/ORCHIDEE_4_1/ORCHIDEE_OL/OOL_SEC/PARAM/orchidee.def	(revision 7877)
@@ -172,4 +172,9 @@
 # Carbon related parameters
 #**************************************************************************
+# Analytic spinup
+# (default n)
+SPINUP_ANALYTIC = _AUTO_
+SPINUP_PERIOD = _AUTO_
+
 # Activate Stomate component
 # (default y)
Index: /tags/ORCHIDEE_4_1/ORCHIDEE_OL/OOL_SEC_STO_FG1trans/PARAM/orchidee.def
===================================================================
--- /tags/ORCHIDEE_4_1/ORCHIDEE_OL/OOL_SEC_STO_FG1trans/PARAM/orchidee.def	(revision 7876)
+++ /tags/ORCHIDEE_4_1/ORCHIDEE_OL/OOL_SEC_STO_FG1trans/PARAM/orchidee.def	(revision 7877)
@@ -192,4 +192,9 @@
 # Carbon related parameters
 #**************************************************************************
+# Analytic spinup
+# (default n)
+SPINUP_ANALYTIC = _AUTO_
+SPINUP_PERIOD = _AUTO_
+
 # Activate Stomate component
 # (default y)
Index: /tags/ORCHIDEE_4_1/ORCHIDEE_OL/OOL_SEC_STO_FG1transnd/PARAM/orchidee.def
===================================================================
--- /tags/ORCHIDEE_4_1/ORCHIDEE_OL/OOL_SEC_STO_FG1transnd/PARAM/orchidee.def	(revision 7876)
+++ /tags/ORCHIDEE_4_1/ORCHIDEE_OL/OOL_SEC_STO_FG1transnd/PARAM/orchidee.def	(revision 7877)
@@ -192,4 +192,9 @@
 # Carbon related parameters
 #**************************************************************************
+# Analytic spinup
+# (default n)
+SPINUP_ANALYTIC = _AUTO_
+SPINUP_PERIOD = _AUTO_
+
 # Activate Stomate component
 # (default y)
Index: /tags/ORCHIDEE_4_1/ORCHIDEE_OL/OOL_SEC_STO_FG2/PARAM/orchidee.def
===================================================================
--- /tags/ORCHIDEE_4_1/ORCHIDEE_OL/OOL_SEC_STO_FG2/PARAM/orchidee.def	(revision 7876)
+++ /tags/ORCHIDEE_4_1/ORCHIDEE_OL/OOL_SEC_STO_FG2/PARAM/orchidee.def	(revision 7877)
@@ -191,4 +191,9 @@
 # Carbon related parameters
 #**************************************************************************
+# Analytic spinup
+# (default n)
+SPINUP_ANALYTIC = _AUTO_
+SPINUP_PERIOD = _AUTO_
+
 # Activate Stomate component
 # (default y)
Index: /tags/ORCHIDEE_4_1/ORCHIDEE_OL/OOL_SEC_STO_FG2nd/PARAM/orchidee.def
===================================================================
--- /tags/ORCHIDEE_4_1/ORCHIDEE_OL/OOL_SEC_STO_FG2nd/PARAM/orchidee.def	(revision 7876)
+++ /tags/ORCHIDEE_4_1/ORCHIDEE_OL/OOL_SEC_STO_FG2nd/PARAM/orchidee.def	(revision 7877)
@@ -191,4 +191,9 @@
 # Carbon related parameters
 #**************************************************************************
+# Analytic spinup
+# (default n)
+SPINUP_ANALYTIC = _AUTO_
+SPINUP_PERIOD = _AUTO_
+
 # Activate Stomate component
 # (default y)
Index: /tags/ORCHIDEE_4_1/ORCHIDEE_OL/OOL_SEC_STO_FG3/PARAM/orchidee.def
===================================================================
--- /tags/ORCHIDEE_4_1/ORCHIDEE_OL/OOL_SEC_STO_FG3/PARAM/orchidee.def	(revision 7876)
+++ /tags/ORCHIDEE_4_1/ORCHIDEE_OL/OOL_SEC_STO_FG3/PARAM/orchidee.def	(revision 7877)
@@ -191,4 +191,9 @@
 # Carbon related parameters
 #**************************************************************************
+# Analytic spinup
+# (default n)
+SPINUP_ANALYTIC = _AUTO_
+SPINUP_PERIOD = _AUTO_
+
 # Activate Stomate component
 # (default y)
Index: /tags/ORCHIDEE_4_1/ORCHIDEE_OL/OOL_SEC_STO_FG3nd/PARAM/orchidee.def
===================================================================
--- /tags/ORCHIDEE_4_1/ORCHIDEE_OL/OOL_SEC_STO_FG3nd/PARAM/orchidee.def	(revision 7876)
+++ /tags/ORCHIDEE_4_1/ORCHIDEE_OL/OOL_SEC_STO_FG3nd/PARAM/orchidee.def	(revision 7877)
@@ -191,4 +191,9 @@
 # Carbon related parameters
 #**************************************************************************
+# Analytic spinup
+# (default n)
+SPINUP_ANALYTIC = _AUTO_
+SPINUP_PERIOD = _AUTO_
+
 # Activate Stomate component
 # (default y)
Index: /tags/ORCHIDEE_4_1/ORCHIDEE_OL/SPINUP_ANALYTIC_FG1/PARAM/orchidee.def
===================================================================
--- /tags/ORCHIDEE_4_1/ORCHIDEE_OL/SPINUP_ANALYTIC_FG1/PARAM/orchidee.def	(revision 7876)
+++ /tags/ORCHIDEE_4_1/ORCHIDEE_OL/SPINUP_ANALYTIC_FG1/PARAM/orchidee.def	(revision 7877)
@@ -191,4 +191,9 @@
 # Carbon related parameters
 #**************************************************************************
+# Analytic spinup
+# (default n)
+SPINUP_ANALYTIC = _AUTO_
+SPINUP_PERIOD = _AUTO_
+
 # Activate Stomate component
 # (default y)
Index: /tags/ORCHIDEE_4_1/ORCHIDEE_OL/SPINUP_ANALYTIC_FG1nd/PARAM/orchidee.def
===================================================================
--- /tags/ORCHIDEE_4_1/ORCHIDEE_OL/SPINUP_ANALYTIC_FG1nd/PARAM/orchidee.def	(revision 7876)
+++ /tags/ORCHIDEE_4_1/ORCHIDEE_OL/SPINUP_ANALYTIC_FG1nd/PARAM/orchidee.def	(revision 7877)
@@ -191,4 +191,9 @@
 # Carbon related parameters
 #**************************************************************************
+# Analytic spinup
+# (default n)
+SPINUP_ANALYTIC = _AUTO_
+SPINUP_PERIOD = _AUTO_
+
 # Activate Stomate component
 # (default y)