Index: branches/ORCHIDEE_2_2/ORCHIDEE_OL/OOL_SEC/PARAM/iodef_xios2.xml
===================================================================
--- branches/ORCHIDEE_2_2/ORCHIDEE_OL/OOL_SEC/PARAM/iodef_xios2.xml	(revision 8133)
+++ branches/ORCHIDEE_2_2/ORCHIDEE_OL/OOL_SEC/PARAM/iodef_xios2.xml	(revision 8181)
@@ -18,5 +18,5 @@
 	  <variable id="using_server"              type="bool">false</variable>
 	  <variable id="using_oasis"               type="bool">false</variable>
-	
+	  <variable id="memory_report"             type="bool">false</variable>
       </variable_definition>
                
Index: branches/ORCHIDEE_2_2/ORCHIDEE_OL/OOL_SEC_STO_FG1trans/PARAM/iodef_xios2.xml
===================================================================
--- branches/ORCHIDEE_2_2/ORCHIDEE_OL/OOL_SEC_STO_FG1trans/PARAM/iodef_xios2.xml	(revision 8133)
+++ branches/ORCHIDEE_2_2/ORCHIDEE_OL/OOL_SEC_STO_FG1trans/PARAM/iodef_xios2.xml	(revision 8181)
@@ -18,5 +18,5 @@
 	  <variable id="using_server"              type="bool">false</variable>
 	  <variable id="using_oasis"               type="bool">false</variable>
-	
+	  <variable id="memory_report"             type="bool">false</variable>	
       </variable_definition>
                
Index: branches/ORCHIDEE_2_2/ORCHIDEE_OL/OOL_SEC_STO_FG1transnd/PARAM/iodef_xios2.xml
===================================================================
--- branches/ORCHIDEE_2_2/ORCHIDEE_OL/OOL_SEC_STO_FG1transnd/PARAM/iodef_xios2.xml	(revision 8133)
+++ branches/ORCHIDEE_2_2/ORCHIDEE_OL/OOL_SEC_STO_FG1transnd/PARAM/iodef_xios2.xml	(revision 8181)
@@ -18,5 +18,5 @@
 	  <variable id="using_server"              type="bool">false</variable>
 	  <variable id="using_oasis"               type="bool">false</variable>
-	
+	  <variable id="memory_report"             type="bool">false</variable>	
       </variable_definition>
                
Index: branches/ORCHIDEE_2_2/ORCHIDEE_OL/OOL_SEC_STO_FG2/PARAM/iodef_xios2.xml
===================================================================
--- branches/ORCHIDEE_2_2/ORCHIDEE_OL/OOL_SEC_STO_FG2/PARAM/iodef_xios2.xml	(revision 8133)
+++ branches/ORCHIDEE_2_2/ORCHIDEE_OL/OOL_SEC_STO_FG2/PARAM/iodef_xios2.xml	(revision 8181)
@@ -18,5 +18,5 @@
 	  <variable id="using_server"              type="bool">false</variable>
 	  <variable id="using_oasis"               type="bool">false</variable>
-	
+	  <variable id="memory_report"             type="bool">false</variable>	
       </variable_definition>
                
Index: branches/ORCHIDEE_2_2/ORCHIDEE_OL/OOL_SEC_STO_FG2nd/PARAM/iodef_xios2.xml
===================================================================
--- branches/ORCHIDEE_2_2/ORCHIDEE_OL/OOL_SEC_STO_FG2nd/PARAM/iodef_xios2.xml	(revision 8133)
+++ branches/ORCHIDEE_2_2/ORCHIDEE_OL/OOL_SEC_STO_FG2nd/PARAM/iodef_xios2.xml	(revision 8181)
@@ -18,5 +18,5 @@
 	  <variable id="using_server"              type="bool">false</variable>
 	  <variable id="using_oasis"               type="bool">false</variable>
-	
+	  <variable id="memory_report"             type="bool">false</variable>	
       </variable_definition>
                
Index: branches/ORCHIDEE_2_2/ORCHIDEE_OL/OOL_SEC_STO_FG3/PARAM/iodef_xios2.xml
===================================================================
--- branches/ORCHIDEE_2_2/ORCHIDEE_OL/OOL_SEC_STO_FG3/PARAM/iodef_xios2.xml	(revision 8133)
+++ branches/ORCHIDEE_2_2/ORCHIDEE_OL/OOL_SEC_STO_FG3/PARAM/iodef_xios2.xml	(revision 8181)
@@ -18,5 +18,5 @@
 	  <variable id="using_server"              type="bool">false</variable>
 	  <variable id="using_oasis"               type="bool">false</variable>
-	
+	  <variable id="memory_report"             type="bool">false</variable>	
       </variable_definition>
                
Index: branches/ORCHIDEE_2_2/ORCHIDEE_OL/OOL_SEC_STO_FG3nd/PARAM/iodef_xios2.xml
===================================================================
--- branches/ORCHIDEE_2_2/ORCHIDEE_OL/OOL_SEC_STO_FG3nd/PARAM/iodef_xios2.xml	(revision 8133)
+++ branches/ORCHIDEE_2_2/ORCHIDEE_OL/OOL_SEC_STO_FG3nd/PARAM/iodef_xios2.xml	(revision 8181)
@@ -18,5 +18,5 @@
 	  <variable id="using_server"              type="bool">false</variable>
 	  <variable id="using_oasis"               type="bool">false</variable>
-	
+	  <variable id="memory_report"             type="bool">false</variable>	
       </variable_definition>
                
Index: branches/ORCHIDEE_2_2/ORCHIDEE_OL/SPINUP_ANALYTIC_FG1/PARAM/iodef_xios2.xml
===================================================================
--- branches/ORCHIDEE_2_2/ORCHIDEE_OL/SPINUP_ANALYTIC_FG1/PARAM/iodef_xios2.xml	(revision 8133)
+++ branches/ORCHIDEE_2_2/ORCHIDEE_OL/SPINUP_ANALYTIC_FG1/PARAM/iodef_xios2.xml	(revision 8181)
@@ -18,5 +18,5 @@
 	  <variable id="using_server"              type="bool">false</variable>
 	  <variable id="using_oasis"               type="bool">false</variable>
-	
+	  <variable id="memory_report"             type="bool">false</variable>	
       </variable_definition>
                
Index: branches/ORCHIDEE_2_2/ORCHIDEE_OL/SPINUP_ANALYTIC_FG1nd/PARAM/iodef_xios2.xml
===================================================================
--- branches/ORCHIDEE_2_2/ORCHIDEE_OL/SPINUP_ANALYTIC_FG1nd/PARAM/iodef_xios2.xml	(revision 8133)
+++ branches/ORCHIDEE_2_2/ORCHIDEE_OL/SPINUP_ANALYTIC_FG1nd/PARAM/iodef_xios2.xml	(revision 8181)
@@ -18,5 +18,5 @@
 	  <variable id="using_server"              type="bool">false</variable>
 	  <variable id="using_oasis"               type="bool">false</variable>
-	
+	  <variable id="memory_report"             type="bool">false</variable>	
       </variable_definition>
                